/* [Basic] */
// Exterior diameter bottom
BottomDiameter = 10.5;

// Exterior diameter top
TopDiameter = 10;

// Button height
KnobHeight=12.25;

// Top rounding
TopRound=0.9;

// Shaft hole depth
ShaftDepth=8;

// Shaft hole diameter
ShaftDiameter = 7;

/* [Hidden] */
$fn=100;

difference() {
  union() {
      // small bottom notch
      cylinder(r=BottomDiameter/2 - 0.5, h = 5);      
            
      // knob body (tapered frm bottom to top diameters)
      translate([0,0,1]) cylinder(r1=BottomDiameter/2, r2=TopDiameter/2, h=KnobHeight-TopRound-1);
      
      // rounded cap      
      translate([0,0,KnobHeight - TopRound]) cylinder(r=TopDiameter/2-TopRound, h=TopRound);
      translate([0,0,KnobHeight - TopRound]) rotate_extrude(convexity = 20) translate([TopDiameter/2 - TopRound, 0, 0])  circle(r=TopRound);
      
  }
    
  // vertical grooves: 360 / 5 = 72 degrees if we want 5 vertical groves
  // for (i=[0:72:360]) translate([(BottomDiameter+0.1) * sin(i)/2, (BottomDiameter + 0.1) * cos(i)/2, 0]) cylinder(r1=0.5, r2 = 0.7, h=KnobHeight);  
  for (i=[0:72:360]) translate([BottomDiameter * sin(i)/2, BottomDiameter * cos(i)/2, 0]) rotate([0,-0.9,(90-i)]) cube([0.7,0.5,KnobHeight*2], center=true);                
      
  
  difference() {
      cylinder(r=ShaftDiameter/2, h = ShaftDepth);
      translate([-(BottomDiameter/2), 1.7,0]) cube([BottomDiameter, BottomDiameter, ShaftDepth]);
  }
    
}


// for (i=[0:45:360]) translate([(ShaftDiameter - 0.2) * sin(i)/2, (ShaftDiameter - 0.2) * cos(i)/2, 0]) cylinder(r=0.2, h=KnobHeight-TopRound);  

for (i=[68:45:300]) translate([(ShaftDiameter -0.2) * sin(i)/2, (ShaftDiameter - 0.2) * cos(i)/2, KnobHeight/2]) rotate([0,-1.5,(90-i)]) cube([0.9,0.9,KnobHeight], center=true);                